Michael Ellerman | 5c02cd2 | 2008-04-24 12:08:22 +1000 | [diff] [blame] | 1 | #!/bin/sh |
Thomas Gleixner | 2874c5f | 2019-05-27 08:55:01 +0200 | [diff] [blame] | 2 | # SPDX-License-Identifier: GPL-2.0-or-later |
Michael Ellerman | 5c02cd2 | 2008-04-24 12:08:22 +1000 | [diff] [blame] | 3 | # |
| 4 | # Copyright © 2008 IBM Corporation |
| 5 | # |
Michael Ellerman | 5c02cd2 | 2008-04-24 12:08:22 +1000 | [diff] [blame] | 6 | |
| 7 | # This script checks prom_init.o to see what external symbols it |
| 8 | # is using, if it finds symbols not in the whitelist it returns |
| 9 | # an error. The point of this is to discourage people from |
| 10 | # intentionally or accidentally adding new code to prom_init.c |
| 11 | # which has side effects on other parts of the kernel. |
| 12 | |
| 13 | # If you really need to reference something from prom_init.o add |
| 14 | # it to the list below: |
| 15 | |
Christophe Leroy | 26deb04 | 2019-04-26 16:23:26 +0000 | [diff] [blame] | 16 | grep "^CONFIG_KASAN=y$" .config >/dev/null |
| 17 | if [ $? -eq 0 ] |
| 18 | then |
| 19 | MEM_FUNCS="__memcpy __memset" |
| 20 | else |
| 21 | MEM_FUNCS="memcpy memset" |
| 22 | fi |
| 23 | |
Michael Ellerman | 5c02cd2 | 2008-04-24 12:08:22 +1000 | [diff] [blame] | 24 | WHITELIST="add_reloc_offset __bss_start __bss_stop copy_and_flush |
Christophe Leroy | 26deb04 | 2019-04-26 16:23:26 +0000 | [diff] [blame] | 25 | _end enter_prom $MEM_FUNCS reloc_offset __secondary_hold |
Michael Ellerman | 5c02cd2 | 2008-04-24 12:08:22 +1000 | [diff] [blame] | 26 | __secondary_hold_acknowledge __secondary_hold_spinloop __start |
Christophe Leroy | c21f5a9 | 2019-06-03 13:00:51 +0000 | [diff] [blame] | 27 | logo_linux_clut224 btext_prepare_BAT |
Benjamin Herrenschmidt | 27f4488 | 2011-09-19 18:27:58 +0000 | [diff] [blame] | 28 | reloc_got2 kernstart_addr memstart_addr linux_banner _stext |
Thiago Jung Bauermann | 05d9a95 | 2019-09-11 13:34:33 -0300 | [diff] [blame] | 29 | __prom_init_toc_start __prom_init_toc_end btext_setup_display TOC. |
| 30 | relocate" |
Michael Ellerman | 5c02cd2 | 2008-04-24 12:08:22 +1000 | [diff] [blame] | 31 | |
| 32 | NM="$1" |
| 33 | OBJ="$2" |
| 34 | |
| 35 | ERROR=0 |
| 36 | |
Masahiro Yamada | 858805b | 2019-08-25 22:28:37 +0900 | [diff] [blame] | 37 | check_section() |
Benjamin Herrenschmidt | 2c51d97 | 2018-10-15 13:49:59 +1100 | [diff] [blame] | 38 | { |
| 39 | file=$1 |
| 40 | section=$2 |
| 41 | size=$(objdump -h -j $section $file 2>/dev/null | awk "\$2 == \"$section\" {print \$3}") |
| 42 | size=${size:-0} |
| 43 | if [ $size -ne 0 ]; then |
| 44 | ERROR=1 |
| 45 | echo "Error: Section $section not empty in prom_init.c" >&2 |
| 46 | fi |
| 47 | } |
| 48 | |
Michael Ellerman | 5c02cd2 | 2008-04-24 12:08:22 +1000 | [diff] [blame] | 49 | for UNDEF in $($NM -u $OBJ | awk '{print $2}') |
| 50 | do |
| 51 | # On 64-bit nm gives us the function descriptors, which have |
| 52 | # a leading . on the name, so strip it off here. |
| 53 | UNDEF="${UNDEF#.}" |
| 54 | |
| 55 | if [ $KBUILD_VERBOSE ]; then |
| 56 | if [ $KBUILD_VERBOSE -ne 0 ]; then |
| 57 | echo "Checking prom_init.o symbol '$UNDEF'" |
| 58 | fi |
| 59 | fi |
| 60 | |
| 61 | OK=0 |
| 62 | for WHITE in $WHITELIST |
| 63 | do |
| 64 | if [ "$UNDEF" = "$WHITE" ]; then |
| 65 | OK=1 |
| 66 | break |
| 67 | fi |
| 68 | done |
| 69 | |
Kumar Gala | da3de6d | 2008-06-13 07:20:58 +1000 | [diff] [blame] | 70 | # ignore register save/restore funcitons |
Andreas Schwab | fe921c8 | 2014-09-13 10:20:17 +0200 | [diff] [blame] | 71 | case $UNDEF in |
| 72 | _restgpr_*|_restgpr0_*|_rest32gpr_*) |
Kumar Gala | da3de6d | 2008-06-13 07:20:58 +1000 | [diff] [blame] | 73 | OK=1 |
Andreas Schwab | fe921c8 | 2014-09-13 10:20:17 +0200 | [diff] [blame] | 74 | ;; |
| 75 | _savegpr_*|_savegpr0_*|_save32gpr_*) |
Stephen Rothwell | 5afd878 | 2010-06-29 20:04:22 +0000 | [diff] [blame] | 76 | OK=1 |
Andreas Schwab | fe921c8 | 2014-09-13 10:20:17 +0200 | [diff] [blame] | 77 | ;; |
| 78 | esac |
Kumar Gala | da3de6d | 2008-06-13 07:20:58 +1000 | [diff] [blame] | 79 | |
Michael Ellerman | 5c02cd2 | 2008-04-24 12:08:22 +1000 | [diff] [blame] | 80 | if [ $OK -eq 0 ]; then |
| 81 | ERROR=1 |
| 82 | echo "Error: External symbol '$UNDEF' referenced" \ |
| 83 | "from prom_init.c" >&2 |
| 84 | fi |
| 85 | done |
| 86 | |
Benjamin Herrenschmidt | 2c51d97 | 2018-10-15 13:49:59 +1100 | [diff] [blame] | 87 | check_section $OBJ .data |
| 88 | check_section $OBJ .bss |
| 89 | check_section $OBJ .init.data |
| 90 | |
Michael Ellerman | 5c02cd2 | 2008-04-24 12:08:22 +1000 | [diff] [blame] | 91 | exit $ERROR |